local currentState, lastState, activeStart, activeEnd, currentTime, nextState, forcedMode, activeMode, inactiveMode, timezone, battState, battAuto

function Initialize()
    lastState = SKIN:GetVariable("LastState", "None")
    SKIN:Bang("!SetVariable", "CurrentState", lastState)
end

function Update()
    activeMode = SKIN:GetVariable("ActiveMode")
    inactiveMode = SKIN:GetVariable("InactiveMode")
    currentState = SKIN:GetVariable("CurrentState", "None")
    forcedMode = SKIN:GetVariable("ForcedMode", "Auto")
    timezone = SKIN:GetMeasure("TimezoneMeasure"):GetValue()/100
    activeStart = toDayEpoch(os.date("*t", SKIN:GetMeasure("ActiveStartTimeMeasure"):GetValue() - timezone * 3600))
    activeEnd = toDayEpoch(os.date("*t", SKIN:GetMeasure("ActiveEndTimeMeasure"):GetValue() - timezone * 3600))
    currentTime = toDayEpoch(os.date("*t", SKIN:GetMeasure("CurrentTimeMeasure"):GetValue() - timezone * 3600))
    battState = SKIN:GetMeasure("MeasureBatteryState"):GetValue()
    battAuto = SKIN:GetVariable("BatteryAuto", "1")
    if (forcedMode == "Dark") then
        nextState = "Dark"
    end
    if (forcedMode == "Light") then
        nextState = "Light"
    end
    if (forcedMode == "Auto") then
        if (currentTime >= activeStart and currentTime <= activeEnd) then
            nextState = activeMode
        else
            nextState = inactiveMode
        end
        if (battState == 0 and battAuto == "1") then
            nextState = "Dark"
        end
    end
    if (nextState ~= currentState) then
        currentState = nextState
        lastState = currentState
        SKIN:Bang("!SetVariable", "CurrentState", lastState)
        SKIN:Bang("!WriteKeyValue", "Variables", "LastState", lastState, "#StatePath#")
        if (currentState == "Dark") then
            SKIN:Bang("!SetWallpaper", "#DarkBackgroundPath#", "Stretch")
            SKIN:Bang("!ActivateConfig", "MySkins-Thanh4p1\\plainText", "mono_white.ini")
            SKIN:Bang("!RefreshApp")
        else
            SKIN:Bang("!SetWallpaper", "#LightBackgroundPath#", "Stretch")
            SKIN:Bang("!ActivateConfig", "MySkins-Thanh4p1\\plainText", "mono_black.ini")
            SKIN:Bang("!RefreshApp")
        end
    end
end

function toDayEpoch(t)
    return t.hour * 3600 + t.min * 60 + t.sec
end