local path, oldInp, oldOut

function string:split(sep)
   local sep, fields = sep or ":", {}
   local pattern = string.format("([^%s]+)", sep)
   self:gsub(pattern, function(c) fields[#fields+1] = c end)
   return fields
end

function Initialize()
    path = SKIN:GetVariable('@', 'n/a')
    path = path .. 'scripts/SolarLunar.lua'
    dofile(path)
end

function Update() 
    local inp, parsed, out
    inp = SKIN:GetMeasure('CurrentDateString'):GetStringValue()
    if (oldInp == inp) then
        return oldOut
    end
    parsed = inp:split('/')
    oldOut = ConvertSolar2Lunar(parsed[1], parsed[2], parsed[3], math.floor(tonumber(parsed[4], 10)/100), false)
    oldInp = inp
    return oldOut
end
